<?php

declare(strict_types=1);

namespace svoboda\pechatalka\models\telegram;

// Files of the project
use svoboda\pechatalka\models\core,
	svoboda\pechatalka\models\account,
	svoboda\pechatalka\models\enumerations\language;

// Framework for Telegram
use Zanzara\Context as context,
	Zanzara\Telegram\Type\Message as message,
	Zanzara\Middleware\MiddlewareNode as node;

// Baza database
use mirzaev\baza\record;

// Built-in libraries
use Error as error;

/**
 * Telegram middlewares
 *
 * @package svoboda\pechatalka\models\telegram
 *
 * @license http://www.wtfpl.net/ Do What The Fuck You Want To Public License
 * @author Arsen Mirzaev Tatyano-Muradovich <arsen@mirzaev.sexy>
 */
final class middlewares extends core
{
	/**
	 * Account (middleware)
	 *
	 * Initialize or registrate the account and write it to the `account` variable inside the `$context`
	 *
	 * @param context $context
	 * @param node $next
	 *
	 * @return void
	 */
	public static function account(context $context, node $next): void
	{
		// Is the process stopped?
		if ($context->get('stop')) return;

		// Initializing the telegram account
		$telegram = $context->getEffectiveUser();

		// Initializing the account
		/* $account = new account()->initialize($telegram); */
		$account = (new account())->initialize($telegram);

		if ($account instanceof record) {
			// Initialized the account

			// Writing the account into the context variable
			$context->set('account', $account);

			// Continuation of the process
			$next($context);
		} else {
			// Not initialized the account

			// Sending the message
			$context->sendMessage('⚠️ *Failed to initialize your Telegram account*')
				->then(function (message $message) use ($context) {
					// Sended the message

					// Ending the conversation process
					$context->endConversation();
				});
		}
	}

	/**
	 * Language (middleware)
	 *
	 * Implement the account language
	 *
	 * @param context $context
	 * @param node $next
	 *
	 * @return void
	 */
	public static function language(context $context, node $next): void
	{
		// Is the process stopped?
		if ($context->get('stop')) return;

		// Initializing the account
		$account = $context->get('account');

		if ($account instanceof record) {
			// Initialized the account

			if ($account->language) {
				// Initialized the language parameter

				try {
					// Writing the account language into the context variable
					$context->set('language', language::{$account->language});
				} catch (error $error) {
					// Not initialized the language

					// Writing the default language into the context variable
					$context->set('language', language::en);
				}
			} else {
				// Not initialized the language parameter

				// Writing the default language into the context variable
				$context->set('language', language::en);
			}

			// Continuation of the process
			$next($context);
		} else {
			// Not initialized the account

			// Sending the message
			$context->sendMessage('⚠️ *Failed to initialize your Telegram account*')
				->then(function (message $message) use ($context) {
					// Sended the message

					// Ending the conversation process
					$context->endConversation();
				});
		}
	}

	/**
	 * Localization (middleware)
	 *
	 * Implement the account language and initialize the localization file
	 *
	 * @param context $context
	 * @param node $next
	 *
	 * @return void
	 */
	public static function localization(context $context, node $next): void
	{
		// Is the process stopped?
		if ($context->get('stop')) return;

		// Initializing the account
		$account = $context->get('account');

		if ($account instanceof record) {
			// Initialized the account

			// Initializing the language
			$language = $context->get('language');

			if ($language instanceof language) {
				// Initialized the language

				// Initializing path to the localization file
				$file = LOCALIZATIONS . DIRECTORY_SEPARATOR . strtolower($language->label()) . '.php';

				if (file_exists($file) && is_readable($file)) {
					// Found the localization file

					// Initializing localization
					$localization = require($file);

					if (is_array($localization)) {
						// Initialized localization

						// Writing localization into the context variable
						$context->set('localization', $localization);

						// Continuation of the process
						$next($context);
					} else {

						// Sending the message
						$context->sendMessage('⚠️ *Failed to initialize localization*')
							->then(function (message $message) use ($context) {
								// Sended the message

								// Ending the conversation process
								$context->endConversation();
							});
					}
				} else {
					// Not found the localization file

					// Sending the message
					$context->sendMessage('⚠️ *Failed to initialize the localization file*')
						->then(function (message $message) use ($context) {
							// Sended the message

							// Ending the conversation process
							$context->endConversation();
						});
				}
			} else {
				// Not initialized language

				// Sending the message
				$context->sendMessage('⚠️ *Failed to initialize language*')
					->then(function (message $message) use ($context) {
						// Sended the message

						// Ending the conversation process
						$context->endConversation();
					});
			}
		} else {
			// Not initialized the account

			// Sending the message
			$context->sendMessage('⚠️ *Failed to initialize your Telegram account*')
				->then(function (message $message) use ($context) {
					// Sended the message

					// Ending the conversation process
					$context->endConversation();
				});
		}
	}

	/**
	 * Settings (middleware)
	 *
	 * Check the account for access to the settings
	 *
	 * @param context $context
	 * @param node $next
	 *
	 * @return void
	 */
	public static function settings(context $context, node $next): void
	{
		// Is the process stopped?
		if ($context->get('stop')) return;

		// Initializing the account
		$account = $context->get('account');

		if ($account instanceof record) {
			// Initialized the account

			if ($account->authorized_settings) {
				// Authorized the account to the settings

				// Continuation of the process
				$next($context);
			} else {
				// Not authorized the account to the settings

				// Initializing localization
				$localization = $context->get('localization');

				if ($localization) {
					// Initialized localization

					// Sending the message
					$context->sendMessage('⛔ *' . $localization['not_authorized_settings'] . '*')
						->then(function (message $message) use ($context) {
							// Sended the message

							// Ending the conversation process
							$context->endConversation();
						});

					// Stopping the process
					$context->set('stop', true);
				} else {
					// Not initialized localization

					// Sending the message
					$context->sendMessage('⚠️ *Failed to initialize localization*')
						->then(function (message $message) use ($context) {
							// Sended the message

							// Ending the conversation process
							$context->endConversation();
						});
				}
			}
		} else {
			// Not initialized the account

			// Sending the message
			$context->sendMessage('⚠️ *Failed to initialize your Telegram account*')
				->then(function (message $message) use ($context) {
					// Sended the message

					// Ending the conversation process
					$context->endConversation();
				});
		}
	}

	/**
	 * System settings (middleware)
	 *
	 * Check the account for access to the system settings
	 *
	 * @param context $context
	 * @param node $next
	 *
	 * @return void
	 */
	public static function system_settings(context $context, node $next): void
	{
		// Is the process stopped?
		if ($context->get('stop')) return;

		// Initializing the account
		$account = $context->get('account');

		if ($account instanceof record) {
			// Initialized the account

			if ($account->authorized_system_settings) {
				// Authorized the account to the system settings

				// Continuation of the process
				$next($context);
			} else {
				// Not authorized the account to the system settings

				// Initializing localization
				$localization = $context->get('localization');

				if ($localization) {
					// Initialized localization

					// Sending the message
					$context->sendMessage('⛔ *' . $localization['not_authorized_system_settings'] . '*')
						->then(function (message $message) use ($context) {
							// Sended the message

							// Ending the conversation process
							$context->endConversation();
						});

					// Stopping the process
					$context->set('stop', true);
				} else {
					// Not initialized localization

					// Sending the message
					$context->sendMessage('⚠️ *Failed to initialize localization*')
						->then(function (message $message) use ($context) {
							// Sended the message

							// Ending the conversation process
							$context->endConversation();
						});
				}
			}
		} else {
			// Not initialized the account

			// Sending the message
			$context->sendMessage('⚠️ *Failed to initialize your Telegram account*')
				->then(function (message $message) use ($context) {
					// Sended the message

					// Ending the conversation process
					$context->endConversation();
				});
		}
	}
}

